package com.ayriksoft.desktopapp.server;

import java.io.File;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.drools.KnowledgeBase;
import org.drools.KnowledgeBaseFactory;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderError;
import org.drools.builder.KnowledgeBuilderErrors;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
//import org.drools.command.GetSessionClockCommand;
import org.drools.event.process.DefaultProcessEventListener;
import org.drools.event.process.ProcessStartedEvent;
import org.drools.event.rule.DefaultAgendaEventListener;
import org.drools.io.Resource;
import org.drools.io.ResourceFactory;
import org.drools.logger.KnowledgeRuntimeLoggerFactory;
import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.WorkflowProcessInstance;


import com.ayriksoft.desktopapp.client.lettermanager.JBPMService;

import com.google.gwt.user.server.rpc.RemoteServiceServlet;
import java.text.DateFormat;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.InitialContext;
import javax.transaction.UserTransaction;
import org.drools.logger.KnowledgeRuntimeLogger;
import org.jbpm.process.workitem.wsht.CommandBasedWSHumanTaskHandler;

public class JBPMServiceImpl extends RemoteServiceServlet implements JBPMService {

    protected StatefulKnowledgeSession session;
    private MockWorkItemHandler mockWorkItemHandler;
    Map<Resource, ResourceType> resources;
     TaskServiceManager tc;

    @Override
    public boolean initializeJbpmSession() {
//		



        try {
            setup();
//            KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
//
//            for (Map.Entry<Resource, ResourceType> entry : this.getResources().entrySet()) {
//                kbuilder.add(entry.getKey(), entry.getValue());
//            }
////        
//            if (kbuilder.hasErrors()) {
//                KnowledgeBuilderErrors errors = kbuilder.getErrors();
//
//                for (KnowledgeBuilderError error : errors) {
//                    System.out.println(">>> Error:" + error.getMessage());
//
//                }
//                throw new IllegalStateException(">>> Knowledge couldn't be parsed! ");
//
//            }
//
//            KnowledgeBase kbase = KnowledgeBaseFactory.newKnowledgeBase();
//
//            kbase.addKnowledgePackages(kbuilder.getKnowledgePackages());

            session = tc.getSession();//kbase.newStatefulKnowledgeSession();
            KnowledgeRuntimeLoggerFactory.newConsoleLogger(session);

            session.addEventListener(new DefaultAgendaEventListener() {
                @Override
                public void afterRuleFlowGroupActivated(org.drools.event.rule.RuleFlowGroupActivatedEvent event) {
                    session.fireAllRules();
                }
            });

            session.addEventListener(new DefaultProcessEventListener() {
                @Override
                public void beforeProcessStarted(ProcessStartedEvent event) {
                    session.insert(event.getProcessInstance());
                }
            });



        } catch (Exception ex) {
            ex.printStackTrace();
            return false;
        }

        return true;
    }

    protected Map<Resource, ResourceType> getResources() {
        try {
            if (resources == null) {
                resources = new HashMap<Resource, ResourceType>();
                resources.put(ResourceFactory.newFileResource(System.getProperty("user.home") + "/V1/EmergencyBedRequestV1.bpmn"), ResourceType.BPMN2);
                resources.put(ResourceFactory.newFileResource(System.getProperty("user.home") + "/V1/bedAssignmentV1.drl"), ResourceType.DRL);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return resources;
    }

    public void setup() {
        try {
            
              tc=TaskServiceManager.getInstance();
//            tc.startService();
                      
            session = tc.getSession();
            tc.connect();

            KnowledgeRuntimeLogger logger = KnowledgeRuntimeLoggerFactory.newThreadedFileLogger(session, "testlog", 1000);
            CommandBasedWSHumanTaskHandler taskHandler = new CommandBasedWSHumanTaskHandler(session);
            session.getWorkItemManager().registerWorkItemHandler("Human Task", taskHandler);
            session.getWorkItemManager().registerWorkItemHandler("Notification System", taskHandler);
            taskHandler.connect();





//        TaskServiceManager taskService = TaskServiceManager.getInstance();
//        taskService.startService();
//        taskService.connectToService();
        } catch (Exception ex) {
            Logger.getLogger(JBPMServiceImpl.class.getName()).log(Level.SEVERE, null, ex);
            ex.printStackTrace();
      throw new RuntimeException("error while creating session", ex);

        }

    }

//    public void setupWorkItemHandlers() {
//
//        mockWorkItemHandler = new MockWorkItemHandler();
//
//        //register the same handler for all the Work Items present in the process.
//        this.session.getWorkItemManager().registerWorkItemHandler("Human Task", mockWorkItemHandler);
//        this.session.getWorkItemManager().registerWorkItemHandler("Notification System", mockWorkItemHandler);
//    }

    @Override
    public boolean startprocess(String processID) {
        try {
//            setupWorkItemHandlers();

 UserTransaction ut = (UserTransaction)new InitialContext().lookup("java:comp/UserTransaction");
        ut.begin();
            //prepare input parameters for the process:
            String date = DateFormat.getDateInstance().format(new Date());
            String entity = "911";
            String patientAge = "21";
            String patientGender = "F";
            String patientStatus = "Critical";

            Map<String, Object> inputVariables = new HashMap<String, Object>();
            inputVariables.put("bedrequest_date", date);
            inputVariables.put("bedrequest_entity", entity);
            inputVariables.put("bedrequest_patientage", patientAge);
            inputVariables.put("bedrequest_patientgender", patientGender);
            inputVariables.put("bedrequest_patientstatus", patientStatus);

            //Start the process using its ID and pass the input variables
            WorkflowProcessInstance processInstance = (WorkflowProcessInstance) session.startProcess("hospitalEmergencyV1", inputVariables);

             session.fireAllRules();
        ut.commit();

            System.out.println("Process Created!");
            
//            //**************   Coordinate Staff   **************//
//
//            //The process must be in the 'Coordinate Staff' task. Let's check the
//            //input parameters received by the handler associated to that task.
//            System.out.println("Coordinate Staff-->" + processInstance.getNodeInstances().iterator().next().getNodeName());
////        
//            System.out.println(date.toString() + "-->" + mockWorkItemHandler.getInputParameter("bedrequest_date"));
//            System.out.println(entity + "-->" + mockWorkItemHandler.getInputParameter("bedrequest_entity"));
//            System.out.println(patientAge + "-->" + mockWorkItemHandler.getInputParameter("bedrequest_patientage"));
//            System.out.println(patientGender + "-->" + mockWorkItemHandler.getInputParameter("bedrequest_patientgender"));
//            System.out.println(patientStatus + "-->" + mockWorkItemHandler.getInputParameter("bedrequest_patientstatus"));
//
//            //let's complete the task emulating the results of this task.
//            Map<String, Object> taskResults = new HashMap<String, Object>();
//            taskResults.put("checkinresults_gate", "3C");
//            mockWorkItemHandler.completeWorkItem(taskResults);
//
//
//            //**************   Notify Gate to Ambulance   **************//
//
//            //Now we are at 'Notify Gate to Ambulance' task. Let's check that the input
//            //parameters configured for this tasks arrived as expected.
//            System.out.println("Notify Gate to Ambulance-->" + processInstance.getNodeInstances().iterator().next().getNodeName());
//
//            System.out.println("3C-->" + mockWorkItemHandler.getInputParameter("checkinresults_gate"));
////        
//            //let's complete the task with a mocked resource
//            taskResults = new HashMap<String, Object>();
//            taskResults.put("checkinresults_notified", "true");
//            mockWorkItemHandler.completeWorkItem(taskResults);
//
//
//            //**************   Check In Patient   **************//
//
//            //In 'Check In Patient' task we are expecting a 'checkinresults_notified'
//            //parameter containing the value returned by the last task
//            System.out.println("Check In Patient-->" + processInstance.getNodeInstances().iterator().next().getNodeName());
//
//            System.out.println("true-->" + mockWorkItemHandler.getInputParameter("checkinresults_notified"));
////        
//            //let's complete the task passing the mocked results
//            taskResults = new HashMap<String, Object>();
//            String checkinDate = java.text.DateFormat.getTimeInstance().format(new Date());
//            taskResults.put("checkinresults_checkedin", "true");
//            taskResults.put("checkinresults_time", checkinDate);
//            mockWorkItemHandler.completeWorkItem(taskResults);
//
//
//            //The process should be completed now. Let's check the 2 output
//            //parameters of the last task: they should be mapped to process variables.
//            System.out.println(processInstance.STATE_COMPLETED + "-->" + processInstance.getState());
//            System.out.println("true-->" + processInstance.getVariable("checkinresults_checkedin"));
//            System.out.println(checkinDate + "-->" + processInstance.getVariable("checkinresults_time"));

        } catch (Exception ex) {
            ex.printStackTrace();
            return false;
        }
        return true;
    }
}
